<template>
  <v-container fluid ma-0 pa-2>
    <v-overlay :value="overlay">
      <v-progress-circular
        indeterminate
        size="64"
      ></v-progress-circular>
    </v-overlay>
    <v-col class="mb-0 pb-0">
      <v-row>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-checkbox
          v-model="chkTarget"
          label="Show Error"
          @change="changeProcessName()"
        ></v-checkbox>
        </v-col>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-select
            :items="serverList"
            v-model="server"
            label="Server Test"
            @input="changeServer()"
            item-text="title"
            item-value="id"
            hide-details
            return-object
          ></v-select>
        </v-col>
        <v-col cols="3" sm="3" class="mb-0 pb-0">
          <v-select
            :items="fileLogs"
            v-model="fileSelected"
            label="File Name"
            hide-details
            @input="changeFile()"
          ></v-select>
          <span v-show="fileSelected != undefined && fileSelected != null && fileSelected != ''"
            @click="routerLink()"
          >Download</span>
        </v-col>
        <v-col cols="2" sm="2">
          <v-text-field
          label="Process Name"
          v-model="processName"
          @keydown.enter="changeProcessName()"
          hide-details
          ></v-text-field>
        </v-col>
        <v-col cols="2" sm="2">
          <v-text-field 
          label="Resouces Name"
          v-model="resourceName"
          @keydown.enter="changeResourceName()"
          hide-details
          ></v-text-field>
        </v-col>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-btn
            @click="changeProcessName()"
            color="primary"
            
          >
            <span>
              Search 
            </span>
            <v-icon>
              search
            </v-icon>
          </v-btn>
        </v-col>
        <v-col cols="1" sm="1" class="mb-0 pb-0">
          <v-btn
            @click="changeResourceName()"
            color="primary"
          >
            <span>
              Search by Resource Name
            </span>
            <v-icon>
              search
            </v-icon>
          </v-btn>
        </v-col>
      </v-row>
      <!-- Custom -->
      <v-row>
        <v-col cols="6" sm="6" class="mt-0 pt-0">
          <v-text-field
          label="File path setup-log-0"
          v-model="customServerURL"
          hide-details
          :disabled='isCustomServer'
          ></v-text-field>
        </v-col>
        <v-col cols="4" sm="4" class="mt-0 pt-0">
          <v-text-field
          label="Server Kafka"
          v-model="customPath"
          hide-details
          :disabled='isCustomServer'
          ></v-text-field>
        </v-col>
        <v-col cols="1" sm="1" class="mt-0 pt-0">
          <v-btn
            @click="realoadFolder()"
            color="primary"
          >
            <span>
              Reload Folder
            </span>
            <v-icon>
              
            </v-icon>
          </v-btn>
        </v-col>
      </v-row>
      <v-col cols="12" sm="12">
        <v-data-table
          :headers="headers"
          :items="kafkalogList"
          class="elevation-2 table-list"
          height="720px"
          fixed-header
        >
          <!-- Search -->
          <template v-slot:item.KAKA_JSON="{ item }">
            <!-- <vue-json-editor 
              :expandedOnStart="true"
              :value='item.KAKA_JSON'
              mode='code'
              :plus="true" height="400px"
              >
            </vue-json-editor> -->
            <v-jsoneditor v-model="item.KAKA_JSON" 
            :options="optionsJson" :plus="true" height="200px" @error="onError"/>

          </template>
          <template v-slot:item.TARGET="{ item }" valign="top" class="v-top"
    >
            <json-viewer
              :value='getTarget(item)'
              copyable
              sort
              :expand-depth="1"
            ></json-viewer>
           <!-- {{ item.KAKA_JSON}} 
           :expand-depth="2"-->
             <!-- <vue-json-editor 
             :expandedOnStart="true"
              mode='code'
              :value='item.KAKA_JSON.payload ? item.KAKA_JSON.payload.function.targets : item.KAKA_JSON.payload'
              >
              JSON.parse(item.replace(/\'/g, '"')).status !== "error" ? item.KAKA_JSON : [] }} 
            </vue-json-editor> -->
            
          </template>
           <template v-slot:item.ROUTER="{ item }" valign="top" class="v-top" v-show="false">
             <json-viewer
              :value='getJSONRouter(item)'
              copyable
              sort
              :expand-depth="1"
            ></json-viewer>
           
          </template>
          <template v-slot:item.RES="{ item }" valign="top" class="v-top" v-show="false">
             <json-viewer
              :value='getJSONRes(item)'
              copyable
              sort
              :expand-depth="1"
            ></json-viewer>
            
          </template>
          <template v-slot:item.CTRT="{ item }" valign="top" class="v-top" v-show="false">             
             <json-viewer
              :value='getJSONCtrt(item)'
              copyable
              sort
              :expand-depth="1"
            ></json-viewer>
          </template>
          <template v-slot:item.log_time="{ item }" valign="top" class="v-top" v-show="false">             
            {{getLogTime(item)}}
          </template>
        </v-data-table>
      </v-col>
    </v-col>
  </v-container>
</template>

<script>
import axios from "axios";
import moment from "moment";
import config from "../../../config/config";
// import VueJsonPretty from "vue-json-pretty";
// import "vue-json-pretty/lib/styles.css";
import cookieClient from 'vue-cookie'
import vueJsonEditor from 'vue-json-editor';
import parseJson from 'parse-json';
import VJsoneditor from 'v-jsoneditor'

export default {
  components: {
    // VueJsonPretty,
    vueJsonEditor,
    parseJson,
    VJsoneditor
  },
  data() {
    return {
      search: "",
      amount: "",
      dialog: false,
      isProcessName: true,
      loadTable: true,
      processName: '',
      resourceName: '',
      singleSelect: false,
      kafkalogList: [
        {
          "KAKA_JSON": {
              "header": {
              },
              "payload": {
                  "user": {
                    
                  },
                  "function": {
                      "targets": [{
                        "processSetupName": "JSON_TEST",
                      }]
                  },
                  "transfer": {
                      "routes": [
                          {
                              
                          }
                      ],
                      "resources": [
                        
                      ]
                  },
                  "translation": {
                      "partners": [
                        
                      ],
                      "mappings": [
                          {
                             
                          }
                      ],
                      "contracts": [
                          
                      ]
                  }
              }
          },
          "log_time": new Date().toString()
      }
      ],
      chkTarget: false,
      optionsJson: {
          theme:'rubyblue',        //default
          //lineNumbers:true,        //default
          mode: 'code',
          readOnly: true
        },
      headers: [
        {
          text: "KAKA_JSON_Full",
          sortable: false,
          align: "left",
          width: "380px",
          height:"100px",
          value: "KAKA_JSON",
        },
        {
          text: "Targets",
          sortable: false,
          align: "top left",
          value: "log_time",
          width: "250px",
          value: "TARGET",
        },
        // {
        //   text: "transfer",
        //   sortable: false,
        //   align: "top left",
        //   value: "log_time",
        //   width: "380px",
        //   value: "transfer",
        // },
       
        {
          text: "Router",
          sortable: false,
          align: "left",
          value: "ROUTER",
        },
        {
          text: "Resouces",
          sortable: false,
          align: "left",
          value: "RES",
        },
        {
          text: "Contract",
          sortable: false,
          align: "left",
          value: "CTRT",
        },
        {
          text: "log_time",
          sortable: false,
          align: "left",
          value: "log_time",
          width: "80px",
        },
      ],
      fileLogs: [],
      server: { id: "Dev-15", path: 'C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\',    title: 'Dev-126', serverURL:  config.API_KAFKA_URL },
      
      serverList: [
        { id: "Local-15",value: "Local-15", path: 'C:\\server\\kafka_2.13-2.6.0\\kafka-logs\\setup-log-0\\',  title: 'Local-15', serverURL:  config.API_KAFKA_URL},
        { id: "Dev-126", value: "Dev-126", path: 'C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\',    title: 'Dev-126', serverURL:  config.API_KAFKA_URL },
        { id: "AWS-213",value: "AWS-213",  path: 'C:\\server\\kafka_2.13-2.6.0\\kafka-logs-128\\',  title: 'AWS-212', serverURL:  config.API_KAFKA_URL },
        { id: "SERVER-41-SETUP", value: "SERVER-41-SETUP", path: 'C:\\tmp\\kafka-logs\\setup-log-0\\',  title: 'Khanh VDI', serverURL:  config.API_KAFKA_URL },
        { id: "SERVER-203-SETUP", value: "SERVER-203-SETUP", path: 'C:\\tmp\\kafka-logs\\setup-log-0\\',  title: 'Dung VDI', serverURL:  config.API_KAFKA_URL },
        { id: "Custom", value: "CUSTOM_PATH", path: '',  title: 'Custom VDI', serverURL:  '' }
      ],
      isCustomServer: true,
      575: "http://172.20.123.15",
      customServerURL: "C:\\server\\kafka_2.13-2.6.0\\kafka-logs\\setup-log-0\\",
      fileSelected: "",
      urlFileSelected: '',
      overlay: false,
    };
  },
  created() {
  },
  watch: {
    overlay (val) {
        val && setTimeout(() => {
          this.overlay = false
        }, 15000)
      },
    kafkalogList(){
      console.log("kafkalogList", this.kafkalogList);
    }
  },
  methods: {
    onError() {
          console.log('error')
      },
    onJsonChange (value) {
      console.log('value', value)
      this.kafkalogList = value;
    },
    getJSON(json){
      if("error" == json.status)
        return JSON.parse(json.KAKA_JSON);
        // return parseJson(json.KAKA_JSON);
      else
        return json.KAKA_JSON;
    },
    getTarget(json){
      try {
        let nJson = null;
        if("error" == json.status)
          nJson = JSON.parse(json.KAKA_JSON).payload.function.targets != undefined ? JSON.parse(json.KAKA_JSON).payload.function.targets : [];
        else
          nJson = json.KAKA_JSON.payload.function.targets != undefined ? json.KAKA_JSON.payload.function.targets : [];
      
        return {
          processSetupName: `(${nJson.length}): (${(nJson[0] != null && nJson[0].processSetupNam != undefined) ? nJson[0].processSetupName : "NULL"}`,
          targets: nJson,
        };
        
      } catch (error) {
         return {
          message: error.message,
          json: json,
        };
      }
    },
    getJSONRouter(json){
      try {
        let nJson = null;
        if("error" == json.status)
          nJson = JSON.parse(json.KAKA_JSON).payload.transfer.routes;
          // return parseJson(json.KAKA_JSON);
        else
          nJson = json.KAKA_JSON.payload.transfer.routes;

        return {
          Number: nJson != null ? nJson.length : 0,
          routes: nJson,
        };
      } catch (error) {
        return {
          JSON: error.message,
          json: json,
        };
      }
      
    },
    getJSONRes(json){
      try {
        let nJson = null;
        if("error" == json.status)
          nJson = JSON.parse(json.KAKA_JSON).payload.transfer.resources;
          // return parseJson(json.KAKA_JSON);
        else
          nJson = json.KAKA_JSON.payload.transfer.resources;

        return {
          Number: nJson != null ? nJson.length : 0,
          resources: nJson,
        };
      } catch (error) {
         return {
          JSON: error.message,
          json: json,
        };
      }
      
    },
    getLogTime(json){
      try {
        if("error" == json.status)
          return "ERROR"
          // return parseJson(json.KAKA_JSON);
        else{
          let arr = json.log_time.split('][INFO][');
          return (arr != undefined && arr.length > 0) ? arr[0] : "ERROR";
  
        }
        
      } catch (error) {
         return {
          JSON: error.message,
          json: json,
        };
      }
    },
    getJSONCtrt(json){
      try {
        let nJson = null;
        if("error" == json.status)
        nJson = JSON.parse(json.KAKA_JSON).payload.translation != undefined ? JSON.parse(json.KAKA_JSON).payload.translation.contracts : [];
          // return parseJson(json.KAKA_JSON);
        else
        nJson = json.KAKA_JSON.payload.translation != undefined ? json.KAKA_JSON.payload.translation.contracts : [];

        return {
          Number: nJson != null ? nJson.length : 0,
          contracts: nJson,
        };
      } catch (error) {
         return {
          JSON: error.message,
          json: json,
        };
      }
     
    },
    async getList(fileId) {
      // const self = this;
      // await axios
      //   .get(`${config.API_KAFKA_URL}/comm/readFile/${this.server.id}&${fileId}`)
      //   .then(function (response) {
      //     self.kafkalogList = response.data.data.Data;
      //     // self.originListChiTieu = response.data.data
      //     // self.totalChiTieu()
      //     console.log("a", response.data.data.Data);
      //   });
    },
    async changeProcessName(){
      this.isProcessName = true;
      console.log("change", this.chkTarget);
      const self = this;
      
      let url = `${self.server.serverURL}/comm/readFile/${this.server.value}&${this.fileSelected}`;
      if(this.processName != undefined && this.processName != ''){
        url = `${self.server.serverURL}/comm/readFile/${this.server.value}&${this.fileSelected}/${this.processName}`;
      }
      // if(this.server.id == "Thanh_VDI"){
      //    url = `${config.API_KAFKA_URL_THANH}/comm/readFile/${this.server.id}&${this.fileSelected}`;
      //     if(this.processName != undefined && this.processName != ''){
      //       url = `${config.API_KAFKA_URL_THANH}/comm/readFile/${this.server.id}&${this.fileSelected}/${this.processName}`;
      //     }
      // }
      if(this.server.value == undefined || this.server.value == null || this.server.value == ""){
        alert("Vui lòng chọn server!!!");
        return;
      } 
        
      if(this.fileSelected == undefined || this.fileSelected == null || this.fileSelected == ""){
        alert("Vui lòng chọn file!!!");
        return;
      }

      
      self.overlay = true;
      await axios
        .get(url)
        .then(function (response) {
          //  = response.data.data.Data;
          let data = response.data.data.Data;
          self.kafkalogList = data;
          self.kafkalogList = data.filter(function (item) {
            if (self.chkTarget){
              return true;
            } else{
              if("error" !== item.status)  return true
            }
          
          })
          self.loadTable = false;
          self.overlay = false;
        });

        if(undefined != self.kafkalogList && self.kafkalogList.length == 0){
          self.kafkalogList.push([]);
        }
        console.log("self.kafkalogList", self.kafkalogList);
    },
    async changeResourceName(){
      this.isProcessName = false;

      console.log("change")
      const self = this;
      self.overlay = true;
      let url = `${self.server.serverURL}/comm/readFileRSN/${this.server.value}&${this.fileSelected}`;
        url = `${self.server.serverURL}/comm/readFileRSN/${this.server.value}&${this.fileSelected}/${this.resourceName}`;
      // if(this.resourceName != undefined && this.resourceName != ''){
      // }
      // if(this.server.id == "Thanh_VDI"){
      //   url = `${config.API_KAFKA_URL_THANH}/comm/readFileRSN/${this.server.id}&${this.fileSelected}/${this.resourceName}`;
      // }
      if(undefined != this.server && 'Custom' == this.server.id){
        url = self.customServerURL != undefined && self.customServerURL != null && self.customServerURL != "" ? self.customServerURL : config.API_KAFKA_URL;
        value = self.customPath;
      }
      await axios
      .get(url)
      .then(function (response) {
        self.kafkalogList = response.data.data.Data;
        self.loadTable = false;
        self.overlay = false;
      });
        console.log("self.kafkalogList", self.kafkalogList);
    },
    
    async getFolder(type) {
      const self = this;
      self.overlay = true;
      let url =  "";
      let value = this.server.value;
      // if(this.server.id == "Thanh_VDI"){
      //   url = config.API_KAFKA_URL_THANH
      // }
      if(undefined != this.server && 'Custom' == this.server.id && type == 'CUSTOM'){
        url = self.customServerURL != undefined && self.customServerURL != null && self.customServerURL != "" ? self.customServerURL : config.API_KAFKA_URL;
        value = self.customPath;
      }
      let jsonServer = {
          "server": value,
          "path": url
        }

      await axios
        .post(`${config.API_KAFKA_URL}/comm/readFolder`, jsonServer)
        .then(function (response) {
          self.fileLogs = response.data.data;
          console.log("readfolder", response);
          self.loadTable = false;
          self.overlay = false;
          // self.originListChiTieu = response.data.data
          // self.totalChiTieu()
        });
    },
    async changeFile() {
      this.urlFileSelected = `${config.API_DOWNLOAD}/${this.server.value == 'Local-15' ? 'kafka-logs/setup-log-0' : 'kafka-logs-128'}/${this.fileSelected}`;
      console.log("urlFileSelected", this.urlFileSelected);
      this.getList(this.fileSelected);
    },
    async changeServer(){
      console.log("server", this.server);
      if(undefined != this.server && 'Custom' == this.server.id){
        this.isCustomServer = false;

      }else{
        this.isCustomServer = true;
        this.getFolder();
      }
     
    },
    async realoadFolder(){
      await this.getFolder('CUSTOM');
    },
    routerLink(jiraTicket){
      // let route = this.$router.resolve('/link/to/page'); // This also works.
      window.open( this.urlFileSelected , '_blank');
    },
  },
};
</script>
<style scoped>
.v-data-table {
  width: 100%;
}
.v-top {
  vertical-align: top;
}
.v-data-table tr td {
  vertical-align: top;
}
.v-data-table tr:hover,
.v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
  background: #fff !important;
}
.v-data-table-header tr th{
  z-index: 9999;
  font-weight: bold !important;
  background-color: red !important;
}

.v-data-table-header > tr > th > span{
  font-weight: bold !important;
  background-color: darkgreen;
}
</style>
